/**
 * \file test.cpp
 *
 * Cipher nevű szorgalmi feladat tesztjei gtest_lite eszközeivel megvalósítva 
 * A szorgalmi feladat megoldásához ezt az állományt nem kell beadni (feltölteni).
 *
 * A ELKESZULT makró vezérli az egyes tesztesetek fordítását, ezzel lehetővé válik
 * hogy kisebb lépésekben teszteljünk.
 *
 */

#include <iostream>

#include "gtest_lite.h"
#include "memtrace.h"
#include "rstring.h"
#include "pool.h"

#define ELKESZULT 1

/* ELKESZULT makró:
    <= 5: RString tesztjei
    >= 10: Összes teszt
*/

int main() {
    GTINIT(std::cin);
    #if ELKESZULT > 0
        //Caesar titkosítás ellenőrzése
        TEST(RString, konstruktorok) {
            RString a(100);
            EXPECT_STREQ("", a);
            EXPECT_EQ(100, a.capacity());
            EXPECT_EQ(0, a.size());
            
            RString b("alma");
            EXPECT_STREQ("alma", b);
            EXPECT_EQ(5, b.capacity());
            EXPECT_EQ(4, b.size());

            RString c("alma", 10);
            EXPECT_STREQ("alma", b);
            EXPECT_EQ(10, c.capacity());
            EXPECT_EQ(4, c.size());
        } END
    #endif


    if (ELKESZULT < 10)
      ADD_FAILURE() << "\nNem futott minden teszteset!" << std::endl;

    GTEND(std::cerr);
    return 0;
}
